<template>
  <div>
    <div
      class="new-task"
      v-for="(todo, index) in todos"
      :key="todo.id"
    >
      <!-- eslint-disable-next-line vuejs-accessibility/form-control-has-label -->
      <input
        v-model="todo.title"
        placeholder="Enter new todo"
        class="input"
        type="text"
      >
      <button
        class="trash"
        @click="deleteTodo(index)"
        :class="{
          'blocked': isOnlyOne
        }"
      >
        <img
          src="../assets/icon-dlt.svg"
          alt="trash"
        >
      </button>
      <button
        class="add"
        @click="addTodo"
        :class="{
          'disabled': !todo.title,
          'removed': showLast(index)
        }"
      >
        <img
          src="../assets/icon-add.svg"
          alt="add"
        >
      </button>
    </div>
  </div>
</template>

<script>
export default {
  name: 'NewTaskList',
  emits: ['draftTodos'],
  props: {
    member: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      todos: [
        {
          userId: this.member.id,
          title: null,
        },
      ],
    };
  },
  watch: {
    todos: {
      handler: function td(newVal) {
        this.$emit('draftTodos', { id: this.member.id, todos: newVal });
      },
      deep: true,
    },
  },
  methods: {
    addTodo() {
      const newTodo = {
        userId: this.member.id,
        title: null,
      };
      this.todos.push(newTodo);
    },
    deleteTodo(index) {
      if (this.isOnlyOne) return;
      this.todos.splice(index, 1);
    },
    showLast(index) {
      return this.todos.length !== index + 1;
    },
  },
  computed: {
    isOnlyOne() {
      return !(this.todos.length > 1);
    },
  },
};
</script>

<style lang="scss">
.new-task{
  display: flex;
  flex-flow: row nowrap;
  align-items: center;
  margin-top: 8px;

  .input {
    height: 36px;
    width: 100%;
    margin: 0 8px 0 0;
    padding: 11px 16px;
    border-radius: 18px;
    border: solid 1px #efefef;
    background-color: #f9f9f9;
    color: #424242;
    font-size: 12px;

    &::placeholder{
      color: #c2c2c2;
      font-style: italic;
      font-size: 12px;
    }
  }

  .trash {
    min-width: 36px;
    height: 36px;
    padding: 10px 11px;
    background-color: #b44b4b;
    margin-right: 8px;
    border-radius: 50%;

    &.blocked {
      opacity: 0.75;
      pointer-events: none;
    }
  }

  .add {
    min-width: 36px;
    height: 36px;
    padding: 10px;
    background-color: #83ba91;
    border-radius: 50%;

    &.disabled {
      opacity: 0.75;
    }
    &.removed {
      visibility: hidden;
    }
  }
}
</style>
